;---------------------------------------------------------------------
; BIOS.S
;---------------------------------------------------------------------
								
xbios_entry:	lea	xbios_tab(pc),a0
		bra.s	bios_handler
			
bios_entry:	lea	bios_tab(pc),a0
bios_handler:	move.l	savptr,a1
		move.w	(sp)+,d0			;Statusregister
		move.w	d0,-(a1)
		move.l	(sp)+,-(a1)			;Returnadr
		movem.l	d3-d7/a3-a7,-(a1)	;Register->Savearea
		move.l	a1,savptr
				
		btst	#13,d0				;in Supermodus ?
		bne.s	super_bios			;ja
		move	usp,sp				;sonst usp benutzen
super_bios:	move.w	(sp)+,d0			;Funktionsnummer
		cmp.w	(a0)+,d0			;max Nummer 
		bge.s	num_error			;Nr zu gro
		lsl.w	#2,d0				;*4
		move.l	(a0,d0.w),d0
		move.l	d0,a0
		bpl.s	direct_call
		move.l	(a0),a0				;indirect
direct_call:	sub.l	a5,a5
		jsr		(a0)
num_error:	move.l	savptr,a1
		movem.l	(a1)+,d3-d7/a3-a7
		move.l	(a1)+,-(sp)
		move.w	(a1)+,-(sp)
		move.l	a1,savptr
		rte
				
nix:		rts

bios_tab:	dc.w	12
		dc.l	Getmpb
		dc.l	Bconstat
		dc.l	Bconin
		dc.l	Bconout
		dc.l	myrwabs	;++++hdv_rw|$80000000		;4
		dc.l	Setexc
		dc.l	Tickcal
		dc.l	mybpb	;++++hdv_bpb|$80000000
		dc.l	Bcostat
		dc.l	mymedia	;++++hdv_mediach|$80000000
		dc.l	Drvmap
		dc.l	Kbshift

xbios_tab:	dc.w	65
		dc.l	Initmous	; 0
		dc.l	nix			;rts
		dc.l	Physbase	; 2
		dc.l	Logbase		; 3
		dc.l	Getrez		; 4
		dc.l	Setscreen	; 5: Setscreen
		dc.l	Setpalette	; 6
		dc.l	nix			; 7: Setcolor
		dc.l	nix	;+++Floprd		; 8
		dc.l	nix			; 9: Flopwr
		dc.l	nix			;10: Flopfmt
		dc.l	Getdsb		;11
		dc.l	nix			;12: Midiws
		dc.l	nix			;13: Mfpint
		dc.l	nix			;14: Iorec
		dc.l	nix			;15: Rsconf
		dc.l	nix			;16: Keytbl
		dc.l	Random		;17: Random
		dc.l	nix			;18: Protobt
		dc.l	nix			;19: Flopver
		dc.l	nix			;20: Scrdmp
		dc.l	nix			;21: Cursconf
		dc.l	nix			;22: Settime
		dc.l	nix			;23: Gettime
		dc.l	Bioskeys	;24: Bioskeys
		dc.l	Ikbdws		;25: Ikbdws
		dc.l	nix			;26: Jdisint
		dc.l	nix			;27: Jenabint
		dc.l	nix			;28: Giaccess
		dc.l	nix			;29: Offgibit
		dc.l	nix			;30: Ongibit
		dc.l	nix			;31: Xbtimer
		dc.l	nix			;32: Dosound
		dc.l	nix			;33: Setprt
		dc.l	nix			;34: Kbdvbase
		dc.l	nix			;35: Kbrate
		dc.l	nix			;36: Prtblk
		dc.l	Vsync
		dc.l	Supexec
		dc.l	nix			;39: Puntaes
		dc.l	nix			;40
		dc.l	nix			;41
		dc.l	nix			;42
		dc.l	nix			;43
		dc.l	nix			;44
		dc.l	nix			;45
		dc.l	nix			;46
		dc.l	nix			;47
		dc.l	nix			;48
		dc.l	nix			;49
		dc.l	nix			;50
		dc.l	nix			;51
		dc.l	nix			;52
		dc.l	nix			;53
		dc.l	nix			;54
		dc.l	nix			;55
		dc.l	nix			;56
		dc.l	nix			;57
		dc.l	nix			;58
		dc.l	nix			;59
		dc.l	nix			;60
		dc.l	nix			;61
		dc.l	nix			;62
		dc.l	nix			;63
		dc.l	Blitmode

;-------------- Bios 0 -------------------------------------------

Getmpb:		move.l	4(sp),a0
		lea	themd.w,a1
		move.l	a1,(a0)
		clr.l	4(a0)
		move.l	a1,8(a0)
		clr.l	(a1)
		move.l	_membot.w,4(a1)
		move.l	_memtop.w,d0
		sub.l	_membot.w,d0
		move.l	d0,8(a1)
		clr.l	$c(a1)
		rts
				
;-------------- Bios 1 -------------------------------------------

Bconstat:	lea	bconstat_vec.w,a0
		bra	bco_jump
								
;-------------- Bios 2 -------------------------------------------

Bconin:		lea	bconin_vec.w,a0
		bra	bco_jump

;-------------- Bios 3 -------------------------------------------

Bconout:	lea	bconout_vec.w,a0
		bra	bco_jump

;-------------- Bios 5 -------------------------------------------

Setexc:		move.w	4(sp),d0
		lsl.w	#2,d0
		sub.l	a0,a0
		lea	(a0,d0.w),a0
		move.l	(a0),d0
		move.l	6(sp),d1
		bmi.s	Setexc1
		move.l	d1,(a0)
Setexc1:	rts

;-------------- Bios 6 -------------------------------------------

Tickcal:	clr.l	d0
		move.w	_timer_ms.w,d0
		rts

;-------------- Bios 8 -------------------------------------------

Bcostat:	lea	bcostat_vec.w,a0
bco_jump:	move.w	4(sp),d0
		lsl.w	#2,d0
		move.l	(a0,d0.w),a0
		moveq	#0,d0
		jmp	(a0)

;-------------- Bios 10 ------------------------------------------

Drvmap:		move.l	_drvbits.w,d0
		moveq	#1,d0
		rts
				
;-------------- Bios 11 ------------------------------------------

Kbshift:	moveq	#0,d0
		move.b	kb_shift.w,d0
		move.w	4(sp),d1
		bmi.s	Kbshift1
		move.b	d1,kb_shift.w
Kbshift1:	rts

;-------------- Xbios 0 ------------------------------------------

Initmous:	tst.w	4(sp)
		beq.s	mouse_off
		move.l	$a(sp),mousevec.w	;Maustreiber
		;++++move.b	#1,mousevec_ok		;++++ padmouse.s
		;	moveq #0,d0
		;	rts

		move.l	6(sp),a3
		cmp.w	#1,4(sp)
		beq.s	mouse_relativ
		cmp.w	#2,4(sp)
		beq.s	mouse_absolut
		cmp.w	#4,4(sp)
		beq.s	mouse_key
		moveq	#0,d0
		rts

mouse_off:	moveq	#$12,d1
		bsr	wr_ikbd
		move.l	#nix,mousevec.w
		;++++move.b	#0,mousevec_ok		;++++ padmouse.s
		bra.s	Initmouse1

mouse_relativ:	lea	mo_trans.w,a2
		move.b	#8,(a2)+
		move.b	#$b,(a2)+
		bsr.s	setmouse
		moveq	#6,d3
		lea	mo_trans.w,a2
		bsr	ws_ikbd
		bra.s	Initmouse1
				
mouse_absolut:	lea	mo_trans.w,a2
		move.b	#9,(a2)+
		move.b	4(a3),(a2)+
		move.b	5(a3),(a2)+
		move.b	6(a3),(a2)+
		move.b	7(a3),(a2)+
		move.b	#$c,(a2)+
		bsr.s	setmouse
		move.b	#$e,(a2)+
		move.b	#0,(a2)+
		move.b	8(a3),(a2)+
		move.b	9(a3),(a2)+
		move.b	10(a3),(a2)+
		move.b	11(a3),(a2)+
		moveq	#16,d3
		lea	mo_trans.w,a2
		bsr	ws_ikbd
		bra.s	Initmouse1
				
mouse_key:	lea	mo_trans.w,a2
		move.b	#$a,(a2)+
		bsr.s	setmouse
		moveq	#5,d3
		lea	mo_trans.w,a2
		bsr	ws_ikbd
Initmouse1:	moveq	#-1,d0
		rts
				
setmouse:	move.b	2(a3),(a2)+
		move.b	3(a3),(a2)+
		moveq	#$10,d1
		sub.b	(a3),d1
		move.b	d1,(a2)+
		move.b	#7,(a2)+
		move.b	1(a3),(a2)+
		rts
				
;-------------- Xbios 2 ------------------------------------------

Physbase:	move.l	JOS_obj_init.w,d0
		lsr.l	#8,d0
		and.b	#$f8,d0			;align 8
		rts

;-------------- Xbios 3 ------------------------------------------
				
Logbase:	move.l	_v_bas_ad.w,d0
		rts

;-------------- Xbios 4 ------------------------------------------
				
Getrez:		moveq	#2,d0			;nur ST-High
		rts
				
;-------------- Xbios 5 ------------------------------------------

Setscreen:	tst.l	4(sp)			;logische Bildadr ?
		bmi.s	no_log
		move.l	4(sp),_v_bas_ad.w
no_log:		tst.l	8(sp)			;physikalische Bildadr 
		bmi.s	no_phys
		move.l	8(sp),d0
		and.l	#$fffff8,d0		;align 8
		lsl.l	#8,d0
		move.l	JOS_obj_init.w,d1
		and.l	#$7ff,d1		;alte DATA lschen
		or.l	d0,d1			;neues einodern
		move.l	d1,JOS_obj_init.w
no_phys:					;Videoauflsung
		rts

;-------------- Xbios 6 ------------------------------------------

Setpalette:	move.l	4(sp),colorptr.w
		rts

;-------------- Xbios 11 -----------------------------------------
						
Getdsb:		moveq	#0,d0
		rts
				
;-------------- Xbios 17 -----------------------------------------

Random:		move.l	_hz_200.w,d0
		rts

;-------------- Xbios 24 -----------------------------------------

Bioskeys:	move.l	#$fc2288-t,keytab.w
		move.l	#$fc2308-t,keytab+4.w
		move.l	#$fc2388-t,keytab+8.w
		rts
								
;-------------- Xbios 25 -----------------------------------------
				
Ikbdws:		moveq	#0,d3
		move.w	4(sp),d3		;Anzahl
		move.l	6(sp),a2		;Zeichenkette
ws_ikbd:	move.b	(a2)+,d1		;Zeichen
		bsr	wr_ikbd
		dbra	d3,ws_ikbd
		rts
				
;-------------- Xbios 37 -----------------------------------------

Vsync:		move.l	_frclock.w,d0
Vsync1:		cmp.l	_frclock.w,d0
		beq.s	Vsync1
		rts
								
;-------------- Xbios 38 -----------------------------------------

Supexec:	move.l	4(sp),a0
		jmp	(a0)
				
;-------------- Xbios 64 -----------------------------------------

Blitmode:	moveq	#0,d0
		rts

;-----------------------------------------------------------------

wr_ikbd:	rts	;+++++ keine HW angeschlossen!!!

;+++ wr_ikbd:	lea	async1,a1
wr_ikbd1:	btst	#5,5*4(a1)				;Sender leer ?
		beq.s	wr_ikbd1				;nein
		move.w	#1400,d2				;Verzgerung
wr_ikbd2:	bsr.s	wr_ikbd3
		dbra	d2,wr_ikbd2
		move.b	d1,(a1)					;senden
wr_ikbd3:	rts
						

init_biosvec:	lea	bconstat_tab,a0
		lea	bconstat_vec.w,a1		;bconst-Vektoren
		moveq	#32-1,d0
copy_io_vec:	move.l	(a0)+,(a1)+
		dbra	d0,copy_io_vec
		rts
				
; Eingabe-Status

bconstat_tab:	dc.l	nix		;Parallel-Port
		dc.l	nix		;RS 232
		dc.l	con_in_stat	;Console
		dc.l	nix		;MIDI
		dc.l	nix		;IKBD
		dc.l	nix		;ASCII
		dc.l	nix		;not used
		dc.l	nix		;not used

; Eingabe
				
bconin_tab:	dc.l	nix		;Parallel-Port
		dc.l	nix		;RS 232
		dc.l	con_in		;Console
		dc.l	nix		;MIDI
		dc.l	nix		;IKBD
		dc.l	nix		;ASCII
		dc.l	nix		;not used
		dc.l	nix		;not used

; Ausgabe-Status

bcostat_tab:	dc.l	nix		;Parallel-Port
		dc.l	nix		;RS 232
		dc.l	con_out_stat	;Console
		dc.l	ikbd_status	;IKBD !!!
		dc.l	nix		;MIDI !!!
		dc.l	nix		;ASCII
		dc.l	nix		;not used
		dc.l	nix		;not used

; Ausgabe

bconout_tab:	dc.l	nix		;Parallel-Port
		dc.l	nix		;RS 232
		dc.l	$fc434c-t	;Console
		dc.l	nix		;MIDI
		dc.l	ikbd_out	;IKBD
		dc.l	nix		;ASCII
		dc.l	nix		;not used
		dc.l	nix		;not used


;-------------- Eingabestatus ---------------------------------------

con_in_stat:	lea	iorec_ikbd.w,a0
		moveq	#-1,d0
		lea	6(a0),a2
		lea	8(a0),a3
		cmp.w	(a3)+,(a2)+
		bne.s	con_in_stat1
		moveq	#0,d0
con_in_stat1:	rts

;-------------- Eingabe ---------------------------------------------

con_in:		bsr.s	con_in_stat
		tst.w	d0
		beq.s	con_in
		move	sr,-(sp)
		or.w	#$700,sr
		move.w	6(a0),d1
		cmp.w	8(a0),d1
		beq.s	con_in2
		addq.w	#4,d1
		cmp.w	4(a0),d1
		bcs.s	con_in1
		moveq	#0,d1
con_in1:	move.l	(a0),a1
		move.l	(a1,d1.w),d0
		move.w	d1,6(a0)
con_in2:	move	(sp)+,sr
		rts
				
;-------------- Ausgabestatus ---------------------------------------

con_out_stat:	moveq	#-1,d0			;immer ok
		rts
				
ikbd_status:	;++++lea	async1,a0
		;++++btst	#5,5*4(a0)		;Sender leer
		;++++beq.s	ikbd_status1		;nein
		moveq	#-1,d0
ikbd_status1:	rts

;-------------- Ausgabe --------------------------------------------

ikbd_out:	move.w	6(a7),d1
		bra	wr_ikbd
				