;---------------------------------------------------------------------
; JAG_BOOT.S
; Main source-file
;
; Original file written by bITmASTER for PureC-Assembler
;
; Converted to DevPac 3.1 format on May 31, 2000 by Matthias Domin
; lines with ;+++ were changed by Matthias Domin
;
; Other important files:
; TOS102.IMG	- German TOS 1.2 adapted to Jaguar-hardware
; FONT.IMG	- 256 8*8 characters
; PRINT.S	- Print-functionusing FONT.IMG
; VAR.H		- TOS-systemvariables
; BIOS.S	- New, Jaguar-specific BIOS/XBIOS-functions
; VIDEO.S	- supports 3 videomodes: 50 hz TV, 60 Hz TV and VGA
; RAMDISK.S	- Installs a RAM-Drive as Drive A
;
; Not so important files:
; TEST.S	- conatins a TOS-sample from the PureC-Assembler package
; STARTGEM.S	- stuff for starting GEM without booting from drives
;		(is similar to the DISKBOOTEN stuff)
;---------------------------------------------------------------------

align4	MACRO
	CNOP 0,4
	ENDM

phrase	MACRO
	CNOP 0,16
	ENDM

dphrase	MACRO
	CNOP 0,32
	ENDM

	OUTPUT c:\develop\jaguar\spiele\jagtos.jag


start     equ $1c0000 ;Startadress in Jaguar.
down      equ $1c0000 ;Downloadadress in Jaguar.


c_down:   DC.b 'JAGR'                  ; Magic to skip Devpac Header.

          DC.w 3                       ; JagOS 3 - Recive & Run. 
          DC.l down                    ; Download adress.
          ;DC.l c_end-c_start           ; Lenght of Jaguar Code.
          DC.l 0                        ; A dc.l 0 are also possible
          DC.l start                   ; Start adress.

	ORG start   ; Position dependent code.
c_start:
jag_code:


								
max_mem	equ	$200000-256*1024		;256 kByte fr RAM-TOS

TOS	equ	1
TV	equ	1


		lea     $f00000,a0
                move.w  #$1861,(a0)	;setze Memory-Configuration
                moveq   #-1,d0
wait1:          dbra    d0,wait1        ;etwas warten
                move.w  #$35cc,d1
                move.w  $f14002,d0      ;read Jumper
                btst    #5,d0
                bne.s   init_refresh
                move.w  #$35dd,d1
init_refresh:   move.w  d1,2(a0)        ;setze Refreshmodus

	IFNE		TOS
		lea	tos,a0
		bsr	init_tos
	ENDC
				
		cmp.l	#$752019f3,memvalid.w
		bne.s	kalt			
		cmp.l	#$237698aa,memval2.w
		bne.s	kalt
		cmp.l	#$5555aaaa,memval3.w
;		beq.s	warm


kalt:		move.w	#$0B00,memcntrl.w	;Bank0=2Mbyte, Bank1=reserv.
		move.l	#max_mem,a0
		move.l	a0,a1
		move.l	#$400,d4			;unterste Grenze frs lschen
		moveq	#0,d0
		moveq	#0,d1
		moveq	#0,d2
		moveq	#0,d3
clr_mem:	movem.l	d0-d3,-(a0)
		movem.l	d0-d3,-(a0)
		movem.l	d0-d3,-(a0)
		movem.l	d0-d3,-(a0)
		cmp.l	d4,a0
		bne.s	clr_mem
		move.l	a1,phystop.w		;oberste Speicheradr

		lea	exception,a0
		add.l	#$02000000,a0
		lea	8.w,a1
except_vec:	move.l	a0,(a1)+
		add.l	#$01000000,a0
		cmp.w	#1024,a1
		bne.s	except_vec

		move.l	$1d0014,a0		;Adr OS-Magic
		cmp.l	#$87654321,(a0)
		beq.s	os_magic
		lea	$1d0008,a0
os_magic:	move.l	4(a0),end_os.w
		move.l	8(a0),exec_os.w
				
												
		move.l	#$752019f3,memvalid.w	;Memconfig ok
		move.l	#$237698aa,memval2.w
		move.l	#$5555aaaa,memval3.w
				
;-------------- Warmstart -------------------------------------------

warm:		move.l	phystop.w,a0
		sub.l	#32768,a0
		move.l	a0,_v_bas_ad		;Video-Basis
		move.w	#32768/4-1,d0		;Bildschirm lschen
.cls:		clr.l	(a0)+
		dbra	d0,.cls

		move.l	#CriticNix,etv_critic.w
		;++++move.l	#Hdv_init,hdv_init.w
		move.l	#CriticNix,hdv_init.w
		;++++move.l	#Hdv_boot,hdv_boot.w
		move.l	#CriticNix,hdv_boot.w
		;++++move.l	#Hdv_mediach,hdv_mediach.w
		move.l	#CriticNix,hdv_mediach.w
		;++++move.l	#Getbpb,hdv_bpb.w
		move.l	#CriticNix,hdv_bpb.w
		;++++move.l	#Rwabs,hdv_rw.w				
		move.l	#CriticNix,hdv_rw.w				

		move.l	end_os.w,_membot.w	;TPA Start
		move.l	_v_bas_ad.w,_memtop.w
				
		move.w	#20,_timer_ms.w
		move.l	#_rts,etv_timer.w
		move.w	#$1111,timerc4.w	;200 Hz / 4

		move.w	#8,nvbls.w
		lea	_vbl_list.w,a0
		move.l	a0,_vblqueue.w
		moveq	#7,d0
clr_vbl:	clr.l	(a0)+
		dbra	d0,clr_vbl
								
		lea	sys_sp,sp
		move.l	#save_area_bios,savptr.w
		move.l	#_rte,$88.w			;Trap #2
		move.l	#bios_entry,$b4.w	;Trap #13
		move.l	#xbios_entry,$b8.w	;Trap #14
		move.l	#$fc9f66-t,$28.w	;LineA
			
		bsr	init_biosvec				
				
		move.l	#_rts,d0
		move.l	d0,vbkerr.w
		move.l	d0,vmiderr.w
		move.l	d0,midivec.w		;Midi-Eingabe-Handler
		move.l	d0,_midisys.w
		move.l	d0,statvec.w		;IKBD-Status-Handler
		move.l	d0,mousevec.w		;Mauspaket-Handler
		move.l	d0,joyvec.w
		move.l	d0,etv_term.w
								
		move.l	#ikbdsys,_ikbdsys.w

		lea	iorec_ikbd.w,a0
		lea	$fc2562-t,a1
		moveq	#14-1,d0
		bsr	copy
			
		bsr	Bioskeys
								

				
;-------------- init Jaguar-Hardware --------------------------------
                lea     $f00000,a0
                move.w  #$7f,$58(a0)    	;Backgroundcolor
                move.l  #$ff000000,$2a(a0)    	;Green Bordercolor (rgb long = ggrrxxbb! )
                move.l  #$070007,$f1a10c 	;DSP alles bigendian
                move.l  #$070007,$f0210c 	;GPU alles bigendian

		move.l  #$402020,bmpscaling	;+++ Initialize scale-factor

	IFD 	TASTATUR
;-------------- Keyboard -----------------------------------------
;keyboard = 7815,5 Bit/s

		lea	async1,a0
		move.b	#$80,3*4(a0)		;Teiler-Zugriff
		move.b	#15,0*4(a0)		;NWT, 15
		clr.b	1*4(a0)			;HWT
		move.b	#$3,3*4(a0)		;8 Datenbits
		move.b	#1,1*4(a0)		;Int bei Daten da | Error
		move.b	#8,4*4(a0)		;Interrupt aktivieren
	ENDC


	IFD TASTATUR
;-------------- reset keyboard ---------------------------------------
		pea	keybd_res
		move.w	#1,-(sp)
		jsr	Ikbdws
		addq.w	#6,sp
	ENDC

	IFD TASTATUR
		move.w	#$7fff,d0
wait_keybd:	jsr	_rts
		dbra	d0,wait_keybd

		lea	async1,a0	;Empfangsbuffer leeren
empty1:		btst	#0,5*4(a0)
		beq.s	empty2
		move.b	(a0),d0
		bra.s	empty1
empty2:	

	ENDC
	
	IFD	TASTATUR
		pea	keybd_mpos
		move.w	#6-1,-(sp)
		jsr	Ikbdws
		addq.w	#6,sp
	ENDC

;-------------- Timer --------------------------------------------

		move.w	#2659-1,$f00050
		move.w	#50-1,$f00052

;-------------- Video --------------------------------------------
;+++
	btst	#4,$00f14003
	beq.s	setPAL
setNTSC:
	moveq	#1,d0		; 3 = VGA, 0 = TV 50Hz, 1= TV 60Hz
	bra.s	setVideo

setPAL:
	moveq	#0,d0		; 3 = VGA, 0 = TV 50Hz, 1= TV 60Hz
	;bra.s	setIRQ
setVideo:
;+++
		;+++moveq	#3,d0		; 3 = VGA
		bsr	VideoTiming

                move.w  #-1,$f00400	; Palette fr ST monochrome
                move.w  #0,$f00402	; (ST-Monitor arbeite ja umgekehrt!)

				
;-------------- Reset-Module ------------------------------------
		;++++bsr		FDC_Reset


;-------------- Object erzeugen ---------------------------------

                lea     object1,a0
                lea     JOS_obj,a1
                lea     JOS_obj_init,a2
                bsr     MakeObject

		move.w	#-1,-(sp)
		move.l	_v_bas_ad.w,-(sp)	;log->phys
		move.l	#-1,-(sp)
		move.w	#5,-(sp)			;Setscreen
		trap	#14
		add.w	#12,sp

                move.l  #JOS_obj,d0
                swap    d0
                move.l  d0,$f00020

                lea     $f00000,a0
                lea     Interrupt,a1
                move.l  a1,$0100.w      ;Interrupt-Routine

				
;-------------- Interrupt initialisieren ---------------------------

	IFNE	TOS
		move.w	#$3f01,$f10020	;clear all Int, enable EINT[0]
	ENDC
				
                move.w  #$1f19,$f000e0  ;clear all Ints and enable VBL
                move.w  #0,$f000e2
                move    sr,d0
                and.w   #$f8ff,d0
                move    d0,sr


		move.w	#1,vblsem.w		;VBL-Semaphore ein
				
		; VMODE setup:
	IFNE	TV
		;+++ move.w	#$4c7,$f00028	; 320*240 pixel visible 
		move.w	#$2c7,$f00028	; (400*240 visible) Composite Sync, 3x
	ELSE
                move.w  #$187,$f00028	;Videomode, $287
	ENDC



		;++++bsr	BootFloppy				
		;++++bsr	FDC_Track0		;LW auf Spur 0


		moveq	#0,d0
		move.l	d0,d1
		move.l	d0,d2
		move.l	d0,d3
		move.l	d0,d4
		move.l	d0,d5
		move.l	d0,d6
		move.l	d0,d7
		move.l	d0,a0
		move.l	d0,a1
		move.l	d0,a2
		move.l	d0,a3
		move.l	d0,a4
		move.l	d0,a5
		move.l	d0,a6

;+++ Erstmal einen Text ausgeben, danach weitersehen

                lea     txt1,a0
                bsr     print_txt
                bsr     crlf

;+++
		move.w	#200,d0
		jsr	delay1
;+++
bv:		;++++bra bv		; Schleife um den Text zu sehen


;-------------- TOS starten ----------------------------------------
	IFNE		TOS
				
		move.b	#2,sshiftmd.w		;hohe Auflsung

		moveq	#0,d0
		jsr	$fca9f8-t		;Blitter-Routinen
		jsr	$fca96e-t		;Bildschirmausgabe
				
		jsr	$fc4af8-t		;GEMDOS init
				
		move.l	#$1d0000,_sysbase.w
	ENDC

;++++
;++++ RAM-Disk als Drive A: einrichten
		clr.l	_drvbits
		move.w	#0,d0			; 0 = Laufwerk A zum booten
		jsr	ramdiskinit		; RAM-DiSK initialisieren
		;+++move.w	#15,d0			; 15 = Laufwerk P
		;+++jsr	ramdiskinit		; RAM-DiSK initialisieren
		move.w	#250,d0			; 5 Sekunden warten
		jsr	delay1
;++++

;++++	IFD DISKBOOTEN
		lea	$fc0518-t,a0		;"PATH="
		lea	$840.w,a1
m1:		cmp.b	#"#",(a0)
		bne.s	m2
		move.l	a1,a2
m2:		move.b	(a0)+,(a1)+
		bpl.s	m1
		;++++move.b	_bootdev.w,d0
		move.w	0,d0	;+++ statt bootdev
		add.b	#"A",d0
		move.b	d0,(a2)

		
		pea	$840.w		; Zeiger auf Environment
		pea	null
		pea	null
		move.w	#5,-(sp)	; Nur ausfhren
		move.w	#$4b,-(sp)	; GEMDOS($4b) = Pexec
		trap	#1
		add.w	#$e,sp
		move.l	d0,a0
		move.l	exec_os.w,8(a0)
				
		pea	$840.w		; Zeiger auf Environment
		move.l	a0,-(sp)	; Zeiger auf Kommando-String
		pea	null
		move.w	#4,-(sp)	; Basepage erzeugen
		move.w	#$4b,-(sp)	; GEMDOS($4b) = Pexec
		trap	#1
		add.w	#$e,sp
;++++	ENDC
					


;		import shit	?????
;		bsr shit	?????
;++++
;++++ hier nun einen Test laufen lassen:
	
;++++	include "test.s"	 ; Aus DEMO.S aus dem PureC-DemoAss-Verzeichnis




;++++ GEM starten ohne von HD zu booten:
;+++	include	"startgem.s"	; aus ST-Computer 10/94 S. 122

; never reached if GEM is started succesfully!
                move.l  #$ff,$f00002a    	;blue Bordercolor (grxb)
loop4e4:	bra.s	loop4e4


;++++ Ansonsten links oben einen Streifen blinken lassen!				
		move.w	#2,-(sp)	; XBIOS(2) = Physbase()
		trap	#14
		addq.l	#2,sp
		move.l	d0,a0
				
blinke:		bsr	delay
		move.w	#0,(a0)
		bsr	delay
		move.w	#-1,(a0)
		bra.s	blinke
				
delay:		moveq	#30,d0
delay1:		move.w	_vbclock.w,d1
delay2:		cmp.w	_vbclock.w,d1
		beq.s	delay2
		dbra	d0,delay1
		rts
;------------------------------------------------------------


tb:             dc.l 0


critic_err:	move.l	etv_critic.w,-(sp)
		rts
				
CriticNix:	moveq	#-1,d0
		rts


Interrupt:    	movem.l d0-a6,-(sp)
                move.w  $f000e0,d0      ;VBL ?

		btst	#4,d0
		bne	ikbd
		
                btst    #0,d0
                beq     no_vbl

;-------------- VBL ----------------------------------------------

		movem.l	JOS_obj_init.w,d0-d1	;Physbase & Height
		movem.l	d0-d1,JOS_obj.w		;neu setzen

		addq.l	#1,_frclock.w
		subq.w	#1,vblsem.w		;VBL-Semaphore
		bmi	not_vbl
				
		addq.w	#1,_vbclock.w

		move.w	nvbls.w,d7				
		beq.s	not_vbl_list		;VBL-Liste leer
		subq.w	#1,d7
		move.l	_vblqueue.w,a0
vbl_list:	move.l	(a0)+,a1		;Slot holen
		cmp.l	#0,a1
		beq.s	vbl_list1		;leer
		movem.l	d7/a0,-(sp)
		jsr	(a1)
		movem.l	(sp)+,d7/a0
vbl_list1:	dbra	d7,vbl_list

				
not_vbl_list:	;++++bsr	FDC_Vbl
;################## NEW Read Joypad 1 and emulate a Mouse ####################
		move.w	#0,$f000e2

		lea	$f14000,a0	; Joystick Port
		move.w	#$800e,(a0)	; Read values RLDU and A+Pause (col 0)
		move.w	(a0),d0		; RLDU
		move.w	2(a0),d4	; A + Pause

		moveq	#0,d1		; initialize dx
		moveq	#0,d2		; and dy

		btst	#11,d0		; right pressed?
		bne.s	no_right
		moveq	#4,d1		; dx = s
		bra.s	set_jm

no_right:	btst	#10,d0		; left pressed?
		bne.s	no_left
		moveq   #-4,d1		; dx = -s
		bra.s	set_jm

no_left:	btst	#9,d0		; down pressed?
		bne.s	no_down
		moveq	#4,d2		; dy = s
		bra.s	set_jm

no_down:	btst	#8,d0		; up pressed?
		bne.s	set_jm
		moveq	#-4,d2		; dy = -s
set_jm:
		move.w	d4,d3		; +++ Toggle scaling of screen-bitmap
		and.w   #2,d4		; Only Button A is interesting
		eor.b	#2,d4		; toggle bit(s)

;		move.b  d1,d3
;		or.b    d2,d3
;		or.b    d4,d3
;		beq.s   no_joymouse	; at least one button pressed?

; Now call the Mouse-event-handler:
		lea	joymouse,a0	; Small buffer for mouse event handling

		or.b	#$f8,d4		; $f8 = Packet-header for Mouse event
		move.b	d4,(a0)		; Mouse buttons (only left button emulated)
		move.b	d1,1(a0)	; relative X-movement	
		move.b	d2,2(a0)	; relative Y-movement

		move.l	mousevec.w,a5	; Get address of Mouse-Event-handler
;		tst.l	a5
;		beq.s   no_joymouse
		move.l	a0,-(sp)
		jsr	(a5)
		addq	#4,sp
		nop

		and.w	#1,d3		; Now Test for "Pause"
		eor.w	#1,d3
		beq.s	no_joymouse
		
		;+++jmp	go		; start cartridge

		;+++Toggle scaling of screen-bitmap:
		move.l	bmpscaling,d0
		cmp.l	#$402020,d0
		beq.s	makesmall
makebig:
		move.l	#$402020,bmpscaling
		bra.s	rebuildobjectlist
makesmall:
		move.l	#$401020,bmpscaling
;		bra.s	rebuildobjectlist
rebuildobjectlist
                lea     object1,a0
                lea     JOS_obj,a1
                lea     JOS_obj_init,a2
                jsr     MakeObject

		move.w	#-1,-(sp)
		move.l	_v_bas_ad.w,-(sp)	;log->phys
		move.l	#-1,-(sp)
		move.w	#5,-(sp)			;Setscreen
		trap	#14
		add.w	#12,sp

                move.l  #JOS_obj,d0
                swap    d0
                move.l  d0,$f00020

no_joymouse:
;#################### Go on with old stuff ################		

not_vbl:	addq.w	#1,vblsem.w
                move.w  #$119,$f000e0  		;VBL-Int besttigen

int_exit:      	
		move.w  #0,$f000e2      	;erhhte Busprioritt aus
                movem.l (sp)+,d0-a6
_rte:           rte

no_vbl:		
		btst	#3,d0		;Timer ?
		beq.s	int_exit	;nein


		addq.l	#1,_hz_200.w
		rol.w	timerc4.w	;/4
		bpl.s	no_timerc
				
		btst	#1,conterm.w	;Repeat ?
;		beq.s	no_repeat	;nein
		bra.s	no_repeat
								
		tst.b	key_repeat.w	;Taste gedrckt ?
		beq.s	no_repeat	;nein
		tst.b	key_count1.w	;Startverzgerung abgelaufen ?
		beq.s	start_repeat	;ja
		subq.b	#1,key_count1.w
		bra.s	no_repeat

start_repeat:	subq.b	#1,key_count2.w	;Wiederholrate
		bne.s	no_repeat		;noch nicht abgelaufen
		move.b	key_delay2.w,key_count2.w
		move.b	key_repeat.w,d0	;zu wiederholende Taste
								;......

;fr AES
										
no_repeat:	move.w	_timer_ms.w,-(sp)
		move.l	etv_timer.w,a0
		jsr		(a0)
		addq.w	#2,sp

no_timerc:		
		move.w	#$819,$f000e0
		bra.s	int_exit
						
_rts:		rts



;-----------------------------------------------------------------------
; Tastatur-IRQ-Behandlung
ikbd:			
		;++++move.w	#$ffff,$f0002a		;Bordercolor

		move.l	_ikbdsys.w,a2

	IFNE		TOS
		jsr		(a2)
	ENDC

		;++++clr.w	$f0002a			;Bordercolor
		;++++move.l	#$008f0000,$f10020		;besttigen
		move.w	#$1019,$f000e0
		bra	int_exit

ikbdsys:	lea	iorec_ikbd.w,a0		;iorec Tastatur
		lea	async1,a1	; keine HW angeschlossen!!
		move.l	vbkerr.w,a2
		sub.l	a5,a5
		;++++move.b	5*4(a1),d0
		;++++and.w	#$1e,d0			;Fehler ?
		;++++bne.s	ikbdsys_err		;ja
		;++++move.b	(a1),d0			;Daten
		;++++jsr	$fc2a46-t
		bra ikbdsys_err	;++++ statt dessen immer Fehler!!!
		rts
				
ikbdsys_err:	jmp	(a2)

		
				
;------------------------------------------------------------------------
go:             moveq   #0,d0
                move.b  $800400,d0
                andi.w  #$1e,d0         ;isolate ROM-width and ROM-speed
                ori.w   #$1861,d0       ;alles andere wie gehabt
                move.w  d0,$f00000      ;Set ROM-Parameter
                move.l  $800408,d1      ;Module-Info
                movea.l $800404,a0      ;go to Game !
                jmp     (a0)
;------------------------------------------------------------------------

object1:        dc.w 0                  ;x
                dc.w 0                  ;y
                dc.w 640                ;Breite
                dc.w 400                ;Hhe (480)
                dc.w 0			;Depth

                	offset
ObjX:           ds.w 1
ObjY:           ds.w 1
ObjW:           ds.w 1
ObjH:           ds.w 1
ObjDepth:       ds.w 1


			text

;a0: Object Parameter
;a1: Adresse Object
;a2: Adresse Init-Object
				
MakeObject:    

		moveq	#0,d0		;DATA vorerst 0
                move.l  a1,d1           ;Adresse Objekt
                add.l   #2*8,d1		;next Object
                lsr.l   #3,d1           ;Phrase
                move.l  d1,d2
                lsr.l   #8,d2
                or.l    d2,d0
                move.l  d0,(a1)+        ;21:11; Data:Link
                move.l  d0,(a2)+	;obj-init

                lsl.l   #8,d1           ;Platz fr Height (10 Bits)
                lsl.l   #2,d1
                or.w	ObjH(a0),d1
				
                lsl.l   #8,d1           ;Platz fr y-Position (11 Bits)
                lsl.l   #3,d1
                or.w    ObjY(a0),d1

                lsl.l   #3,d1           ;Platz fr Typ (3 Bits)
                or.w    #1,d1			;++++scaled bitmap

                move.l  d1,(a1)+        ;8:10:11:3
                move.l  d1,(a2)+	;obj-init

                move.w  ObjW(a0),d0     ;Breite
                lsr.w   #6,d0           ;/8*8, in Phrases

                move.w  d0,d1           ;IWIDTH
                lsr.w   #4,d1
                ext.l   d1
		or.l	#$10000,d1	;release

                move.l  d1,(a1)+

                move.w  d0,d1

                lsl.l   #8,d1           ;Platz fr DWITH
                lsl.l   #2,d1
                or.w    d0,d1           ;DWITH

                lsl.l   #3,d1           ;Platz fr Pitch
                or.w    #1,d1           ;Pitch

                lsl.l   #3,d1           ;Platz fr Depth
                or.w    ObjDepth(a0),d1

                lsl.l   #8,d1           ;Platz fr x-Position
                lsl.l   #4,d1
                or.w    ObjX(a0),d1
                move.l  d1,(a1)+

                clr.l   (a1)+           ;scaled
	IFNE TV
		move.l	bmpscaling,d0
	ELSE
		move.l  #$404020,d0
        ENDC
                move.l  d0,(a1)+

                clr.l   (a1)+
                move.l  #4,(a1)+        ;Stop-Objekt

                rts

;------------------------------------------------------------------------------
exception:	bsr.s	exception_		;PC aufm Stack
		nop
				

exception_:	move.l	(sp)+,proc_pc.w
		movem.l	d0-d7/a0-a7,proc_regs.w
		move	usp,a0
		move.l	a0,proc_usp.w
		moveq	#16-1,d0
		lea	proc_stk.w,a0
		move.l	sp,a1
save_stack:	move.w	(a1)+,(a0)+
		dbra	d0,save_stack
		
		move.l	#$12345678,proc_lives.w
				
		clr.w	spalte
		lea	except_txt1,a0
		bsr	print_txt
		moveq	#0,d0
		move.b	proc_pc.w,d0
		bsr	print_long
		lea	except_txt2,a0
		bsr	print_txt
		move.l	2(sp),d0
		bsr	print_long
		moveq	#2-1,d1
		lea	proc_regs.w,a0
except2:	bsr	crlf
		moveq	#8-1,d2
except3:	move.l	(a0)+,d0
		bsr	print_long
		moveq	#" ",d0
		bsr	print
		dbra	d2,except3
		dbra	d1,except2		

exception1:	bra.s	exception1
				
except_txt1:	dc.b	"exception ",0
except_txt2:	dc.b	" at ",0
	
			even
				
init_tos:	add.l	#192*1024,a0
		lea	$200000,a1
		move.w	#192*1024/16,d0
copy_tos:	move.l	-(a0),-(a1)
		move.l	-(a0),-(a1)
		move.l	-(a0),-(a1)
		move.l	-(a0),-(a1)
		dbra	d0,copy_tos
		rts

copy:		move.b	(a1)+,(a0)+
		dbra	d0,copy
		rts
				
null:		dc.w	0
txt1:           dc.b "!        Jaguar-Booter V0.3            !",0
keybd_res:	dc.b	$80,1

keybd_mpos:	dc.b	$e,0
		dc.w	80,50

                align4
joymouse:	ds.l	1
bmpscaling:	ds.l	1

		even
	include	"var.h"
		even
	include "bios.s"
		even
	include "video.s"
		even
	include	"print.s"
		even
	include	"ramdisk.s"

		even
font:	INCBIN	"FONT.IMG"	; Font 
                
		even
tos:	INCBIN "TOS102.IMG"	; special TOS 1.02


