;---------------------------------------------------------------
; VAR.H
; Defines TOS-specific variables
;---------------------------------------------------------------


; t defines the offset between, the TOS-location in the Jaguar
; and a real Atari ST
t				equ $fc0000-$1d0000


; Hardware-Adressen

async1			equ	$f17000+$01e1		;Basis-Adr async1

proc_lives		equ	$380
proc_regs		equ	$384
proc_pc			equ	$3c4
proc_usp		equ	$3c8
proc_stk		equ	$3cc

etv_timer		equ	$400
etv_critic		equ	$404
etv_term		equ	$408
etv_xtra		equ	$40c

memvalid		equ	$420
memcntrl		equ	$424
resvalid		equ	$426
resvector		equ	$42a
phystop			equ	$42e

_membot			equ	$432
_memtop			equ	$436
memval2			equ	$43a
flock			equ	$43e
seekrate		equ	$440
_timer_ms		equ	$442
_fverify		equ	$444
_bootdev		equ	$446
palmode			equ	$448
defshiftmd		equ	$44a
sshiftmd		equ	$44c
_v_bas_ad		equ	$44e
vblsem			equ	$452
nvbls			equ	$454
_vblqueue		equ	$456
colorptr		equ	$45a
screenpt		equ	$45e
_vbclock		equ	$462
_frclock		equ	$466
hdv_init		equ	$46a
swv_vec			equ	$46e
hdv_bpb			equ	$472
hdv_rw			equ	$476
hdv_boot		equ	$47a
hdv_mediach		equ	$47e
_cmdload		equ	$482
conterm			equ	$484
trp14ret		equ	$486
criticret		equ	$48a
themd			equ	$48e
____md			equ	$49e
savptr			equ	$4a2
nflops			equ	$4a6
_hz_200			equ	$4ba
_drvbits		equ	$4c2
_vbl_list		equ	$4ce
_sysbase		equ	$4f2
end_os			equ	$4fa
exec_os			equ	$4fe
memval3			equ	$51a
bconstat_vec		equ	$51e
bconin_vec		equ	$53e
bcostat_vec		equ	$55e
bconout_vec		equ	$57e

;-------------- TOS-abhaengige Adressen ------------------------------
sys_sp			equ	$755a		;System-Stackpointer
save_area_bios		equ	$93a		;Savearea, Adr kommt nach savptr

				offset	$a54
rs232_inbuf:	ds.b 256
rs232_outbuf:	ds.b 256
iorec_rs232in:	ds.l 1
				ds.w 5
iorec_rs232out:	ds.l 1
				ds.w 5
				ds.w 1
				ds.w 1
				ds.w 1
iorec_ikbd:		ds.l 1
				ds.w 5
ikbd_buffer:	ds.b 256
iorec_midi:		ds.l 1
				ds.w 5
midi_buffer:	ds.b 128
midivec:		ds.l 1
vbkerr:			ds.l 1
vmiderr:		ds.l 1
statvec:		ds.l 1
mousevec:		ds.l 1
clockvec:		ds.l 1
joyvec:			ds.l 1
_midisys:		ds.l 1
_ikbdsys:		ds.l 1
Kbstate:		ds.b 1
Kbindex:		ds.b 1

				offset	$e61
kb_shift:		ds.b 1
keytab:			ds.l 3
mo_trans:		ds.b 17

key_repeat:		ds.b 1
key_count1:		ds.b 1
key_count2:		ds.b 1
key_delay1:		ds.b 1
key_delay2:		ds.b 1
				ds.l 1
timerc4:		ds.w 1

;----- globale Floppy Variablen -------

				offset $9f6

retry:          ds.w 1
wpstat:         ds.b 2
wplatch:        ds.b 2
acctim:         ds.l 2                  ;letzte Zugriffszeit
motoron:        ds.w 1
cdesel:         ds.w 1
cdrv:           ds.w 1                  ;Laufwerk
ctrack:         ds.w 1                  ;Spur
csect:          ds.w 1                  ;Sektor
cside:          ds.w 1                  ;Seite
ccount:         ds.w 1                  ;Sektorzhler
cbuf:           ds.l 1                  ;DMA-Buffer
c_spt:          ds.w 1                  ;Sektoren pro Track
cinterlv:       ds.w 1                  ;Interleave Faktor
cvirgin:        ds.w 1
csectab:        ds.l 1                  ;Zeiger auf Tabelle mit Sektornummern
tmpdma:         ds.l 1
cdeferr:        ds.w 1
cerror:         ds.w 1
csavreg:        ds.l 9                  ;Platz fr 9 Register
c_dsb:          ds.l 2


;------ JOS-Variablen ----------

				offset 	$600
JOS_obj:		ds.b	8*8				;max 8 Objecte
JOS_obj_init:	ds.b	8*2				;zum init. des Obj beim VBL
JOS_fdc_motor:	ds.w	1				;Motor Spin-Up & Spin-Down
JOS_fdc_result:	ds.b	7				;Result-Bytes vom FDC
JOS_fdc_chg:	ds.b	1				;Diskwechsel bemerkt

				text
				
				
				